PROBLEM LINKDIFFICULTYCAKEWALK PREREQUISITESPROBLEMYou need to find the representation of a given integer N as a sum of powers of two up to 2^{11} with the smallest number of summands (repetitions in representation are allowed). QUICK EXPLANATIONThe problem can be solved by greedy algorithm: at each step we should take the largest possible menu that we can. To prove this noticed that if we order two equal menus, say 4 and 4, then we can order instead one menu of cost 8. In this problem you can implement this approach in any way you like but the easiest and fastest way gives the following pseudocode: res = 0 for i = 11 to 0 res = res + N div 2^{i} N = N mod 2^{i} EXPLANATIONAt first we reveal the answer and then will prove it in detail. Write N as Q * 2048 + R, where Q and R are nonnegative integers and R < 2048. Then the answer is Q + bitCount(R), where bitCount(X) is the number of ones in binary representation of X. If R = 2^{h[1]} + 2^{h[2]} + ... + 2^{h[K]} is a binary representation of R then the optimal representation of N is N = 2048 + ... + 2048 + 2^{h[1]} + 2^{h[2]} + ... + 2^{h[K]} where we have Q copies of 2048. Let’s call this approach formula approach. Another way to come up with this answer is to use Greedy Algorithm. That is, at each step you should take the largest possible summand among {1, 2, 4, 8, ..., 2048} that is not greater than the current value of N and then subtract it from N. In fact, this problem is a special case of Changemaking problem and in general it should be solved using Dynamic Programming or Integer Linear Programming but this set of coin values is special and admit using of Greedy Algorithm as we will see below. Now we discuss why both of these approaches are correct. 1. Formula Approach.Let’s prove that formula approach is correct. Consider some representation of N as a sum of allowed powers of two. Let there is exactly C[K] occurrences of 2^{K} in this representation. Then we have N = C[0] * 1 + C[1] * 2 + C[2] * 4 + ... + C[11] * 2048 Note that the total number of summands here is C[0] + C[1] + ... + C[10] + C[11]. Assume that for some K < 11 we have C[K] >=2, that is, we have at least two copies of 2^{K} in the representation of N. Since K < 11 then the price 2^{K+1} is allowed. Hence we can replace two copies of 2^{K} by one copy of 2^{K+1} not changing the value of sum but decreasing total number of summands. Thus, for optimal representation we should have We will show that under the constraints (1) representation of N is uniquely determined. Of course this unique representation will be the optimal one. At first note that R = C[0] * 1 + C[1] * 2 + C[2] * 4 + ... + C[10] * 1024 <= 1 + 2 + 4 + ... + 1024 = 2047 < 2048. Hence 2048 * C[11] <= N < 2048 * (C[11] + 1) or C[11] <= N / 2048 < C[11] + 1 which means by one of the definition of floor function that C[11] = floor(N / 2048) = Q. So C[11] is uniquely determined under the constraints (1) and equals to Q. Further note that due to (1) C[10]C[9]...C[1]C[0] is a binary representation of R and hence C[0], C[1], ..., C[10] are also uniquely determined under the constraints (1). Thus we have found this unique representation. Next we have bitCount(R) = C[0] + C[1] + ... + C[10]. Hence the total number of summands in this representation is Q + bitCount(R) as was announced earlier. The complexity of this method is O(K), where K = 12 is the total number of powers of two that we are allowed to use. 2. Greedy Approach.Now let’s see why greedy approach produces the same solution. Clearly at first several steps we will take the 2048 until we get a number strictly less than 2048. Then we will consider powers of two in descending order starting from 1024 and take the current power of two if it is not greater than the current value of N. It is quite clear that this process generates exactly the binary representation of N. Thus the whole representation coincides with the constructed above. There are several ways how to implement this algorithm in this problem. First one is simple but slower in general. Namely, we have an outer loop of the form while (N > 0). Then at each iteration of this loop we simply check in one loop all allowed powers of two in descending order until we find the power of two, say 2^{X}, that is not greater than the current value of N. After that we decrease N by 2^{X} and increase answer by 1. The complexity of this approach is O(N / 2^{K1} + K^{2}) in the worst test case. This is because at first N / 2^{K1} steps we have only one iteration of inner loop (we break at 2048) and then we have at most K steps for each of which we have at most K steps in the inner loop. In second method we swap outer and inner loop of the first method. So we iterate over allowed powers of two in descending order and for each power of two we have an inner loop of the form while (N >= 2^{X}) in the body of which we do the same as for the first method, that is, decrease N by 2^{X} and increase answer by 1. The complexity of this method is O(N / 2^{K1} + K). Strictly speaking the number of basic operations in this method is O(answer + K). N / 2^{K1} + K is an upper bound for the answer. Analyzing second implementation of the greedy approach it is easy to see how to make it faster. For each power of two we have the following inner loop while N >= 2^{X} do N = N  2^{X} res = res + 1 Clearly this equivalent to res = res + N div 2^{X} N = N mod 2^{X } Thus we obtain third implementation of the greedy algorithm with complexity O(K). 3. Dynamic Programming Approach.Now let’s consider another approach that allows to find the answer for arbitrary set of coin values in reasonable time. We will use dynamic programming. Let d_{1}, ..., d_{K} be the set of allowed coin values (they all are positive). Denote by F(P) the minimal number of coins needed to represent P by this set of coins (repetitions in representation are allowed). Clearly F(0) = 0. Consider some value of P > 0. Then it is quite clear that where we set for convenience F(x) = INF for x < 0 (INF is some very large number). But let’s prove this formally. At first consider the optimal representation for P. Let it be P = A_{1} + ... + A_{L} where L = F(P) and each A_{i} is of course equal to one of d_{j}. Then A_{2} + ... + A_{L} is some representation of P – A_{1} of the length L – 1. By definition of F(P – A_{1}) we have Now let d_{j} be those coin value for which F(P  d_{j}) is minimal among F(P  d_{1}), F(P  d_{2}), ..., F(P  d_{K}). Let B_{1}, ..., B_{Z} be the optimal representation for P  d_{j}. That is P  d_{j} = B_{1} + ... + B_{Z} and Z = F(P – d_{j}). But then P = d_{j} + B_{1} + ... + B_{Z}. So P has a representation of the length Z + 1 which by definition of F(P) means that Now (2) follows from (3) and (4). Formula (2) allows to find all values F(0), F(1), ..., F(N) in a simple double loop. So F(N) can be found in O(N * K) time with O(N + K) memory. SETTER'S SOLUTIONCan be found here. TESTER'S SOLUTIONCan be found here. RELATED PROBLEMSGreedy Change (Codeforces Beta Round #10, problem E)
This question is marked "community wiki".
asked 23 Jul '12, 00:03

hi @anton_lunyov..could you please explain the dynamic programming part more clearly ..i dont understand how you got eqn (2) and also what Ai stands for and how L=F(P)..please explain the steps..thanks answered 16 Dec '13, 16:08

Can anyone tell me why this Python solution gets runtime error? http://www.codechef.com/viewsolution/1187366 answered 23 Jul '12, 01:13
I am not familiar with Python but it seems that you are using file for input. You should read from the standard input and output to the standard output.
(23 Jul '12, 01:18)
I actually am using standard input. It reads from an input file on my computer (for testing), but if that file doesn't exist (when I submit) it uses raw_input() instead. I've tested this method on the codechef judge and it works for other problems, so I don't understand why it gets runtime error now.
(23 Jul '12, 01:49)
1
The reason is:
(23 Jul '12, 14:40)
That doesn't make sense... bin is a builtin function, how could it not be defined? I thought it must be something with the input because this solution http://www.codechef.com/viewsolution/1187415 got accepted.
(23 Jul '12, 20:26)
1
You will be angry, but your code works  http://www.codechef.com/viewsolution/1191924 , is there problem with whitespace, PY is "whitespace sensitive", isn't it?
(23 Jul '12, 20:38)
That link doesn't work, but I see that you got my solution accepted. So I tried it myself and got runtime error http://www.codechef.com/viewsolution/1191926. (this is the exact same code that you got accepted, right?) And yeah, python is whitespacesensitive, but I don't see how that could be the problem because the solution I posted above got accepted. Something really weird is going on...
(23 Jul '12, 20:52)
problem was with comma in link, try again, is your editor replacing multiple spaces with one tab (but it is just a tip)?
(23 Jul '12, 20:55)
@anton_lunyov, can you make diff of these two solutions on filesystem?
(23 Jul '12, 20:56)
wow this is total B.S. How does the exact same code get accepted for betlista but runtime error for me???
(23 Jul '12, 23:17)
showing 5 of 9
show all

note on my code: initialize the array of power 2, starting from 0 goes to 11. after getting p, starting from the maximum value of array(here 2048, index is arr[11]=2048) and check if p is equal to or greater than that value. if so, p=parr[i], count++. i also increased i++ so that continues from the index last visited. thnx answered 23 Dec '13, 09:42

runtime error... please help !! answered 24 Jul '14, 12:45

Write N as Q * 2048 + R, where Q and R are nonnegative integers and R < 2048. Then the answer is Q + bitCount(R), where bitCount(X) is the number of ones in binary representation of X. This is my doubt as if N is less than 2048, we cant express the same as Q* 2048+ R as we are told that Q and R are integers( not a fraction ). answered 03 Sep '14, 08:12

how to solve this problem in easy way please tell me... answered 04 Oct '14, 13:42

can somebody please help me with my code here is the link : http://ideone.com/NovXIt i am getting wrong answer . answered 05 Nov '14, 23:08

Why Isn't THis Approach Working ??
answered 14 Feb '15, 09:05

Hi, i have tried to solve using recursion code follows,but not being accepted as solution please help,thanks int n,p,divi,rem,t; int calc(int num){
} int main(){
} answered 24 May '16, 23:06

include<stdio.h>int main() { int t,p,count,key; scanf("%d",&t); while(t) { scanf("%d",&p); if((p%2048)==0) { count=p/2048; printf("%d",count); printf("\n"); } else { count=count_1(p); if(p/2048>1) { key=p/2048; count=count+(key1); printf("%d",count); printf("\n"); } else { printf("%d",count); printf("\n"); } } } return 0; } int count_1(int n) { int ctd; while(n) { n=n&(n1); ctd++; } return ctd; } it satisfy every case but during submission wrong answer answered 27 Aug '16, 17:01

easiest way to solve the problem import java.util.*; import java.lang.*; import java.io.*; class Codechef { public static void main (String[] args) throws java.lang.Exception {
} answered 26 Mar '17, 01:28

i need to convert the set of number into "k", "mil", "bil" for my php website (Soundcloud downloader) when i implement this code the website automatically turns into error 500. Expert advice needed answered 09 Apr '17, 15:31

I found one of the best solution for it, ie: convert decimal to binary and count the number of ones in it. that's the answer. for eg: decimal: 253 binary: 11111101 no of ones: 7 that's the answer. For No > 2048, you have to use rest logic. Thnx.
link
This answer is marked "community wiki".
answered 28 Jun '17, 01:06

Hey i tried the code using DP but the solution is not being accepted , the code works for the sample test cases and any other test case that i can think of . Please help Here is the link to my code : https://www.codechef.com/viewsolution/14492082 answered 11 Jul '17, 07:58

can any one please check my code .I don't know what is wrong it passed all sample tests. https://www.codechef.com/viewsolution/17515413 answered 23 Feb '18, 21:08

Hello, guys, I have a website for downloading music from SoundCloud. http://soundcloudmp3downloader.com/ And I hope u could help me.. how can I get the information about bitrate of SC tracks? is it possible? any idea? answered 13 Apr '18, 23:13

My solution is a bit different and is very short if you are using C++ and stl as your tool to solve the problem It uses a greedy approach to find the nearest value just smaller than or equal to n from the menu list.
Here menuList is an array of the powers of 2 up to the required item  [1,2,4,8...]
link
This answer is marked "community wiki".
answered 05 Aug '18, 15:25

int price[12] = {1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048};
answered 10 Aug '18, 22:09

if someone interested in dynamic programming solution
answered 30 Dec '18, 17:20
